

Application create: #CwcIcfp2001 with:
    (#( AbtCFSAdditionsApp)
        collect: [:each | Smalltalk at: each ifAbsent: [
            Application errorPrerequisite: #CwcIcfp2001 missing: each]])!

CwcIcfp2001 becomeDefault!
Object subclass: #CwcDecorationContext
    instanceVariableNames: 'b em i s tt u size color '
    classVariableNames: ''
    poolDictionaries: ''!

CwcIcfp2001 becomeDefault!
Object subclass: #CwcNode
    instanceVariableNames: 'parent token '
    classVariableNames: ''
    poolDictionaries: ''!

CwcIcfp2001 becomeDefault!
CwcNode subclass: #CwcTagNode
    instanceVariableNames: 'children '
    classVariableNames: ''
    poolDictionaries: ''!

CwcIcfp2001 becomeDefault!
CwcTagNode subclass: #CwcRootNode
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

CwcIcfp2001 becomeDefault!
CwcNode subclass: #CwcTextNode
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

CwcIcfp2001 becomeDefault!
Object subclass: #CwcStreamConverter
    instanceVariableNames: 'inputStream bufferedObjects '
    classVariableNames: ''
    poolDictionaries: ''!

CwcIcfp2001 becomeDefault!
CwcStreamConverter subclass: #CwcStringToTokensStreamConverter
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

CwcIcfp2001 becomeDefault!
Object subclass: #CwcToken
    instanceVariableNames: 'contents context '
    classVariableNames: ''
    poolDictionaries: ''!

CwcIcfp2001 becomeDefault!
CwcToken subclass: #CwcTag
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

CwcIcfp2001 becomeDefault!
CwcToken subclass: #CwcText
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

CwcIcfp2001 becomeDefault!
Object subclass: #CwcTokenCollectionOptimizer
    instanceVariableNames: 'tokenCollection contexts rootNode '
    classVariableNames: ''
    poolDictionaries: ''!

CwcIcfp2001 becomeDefault!
Application subclass: #CwcIcfp2001
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: 'CfsConstants '!


CwcIcfp2001 becomeDefault!

!Character publicMethods !

cwcIsWhitespace

	^(Array with: Tab with: Cr with: Lf with: Space) includes: self! !

!CwcDecorationContext class publicMethods !

new

	^super new initialize! !

!CwcDecorationContext publicMethods !

= anObject

	anObject class = self class ifFalse: [ ^false ].

	^(b==anObject b) & (em==anObject em) & (i==anObject i) & (s==anObject s) & (tt==anObject tt) & (u==anObject u) & (size==anObject size) & (color==anObject color)!

b
	^b!

changeContext_B

	b := true.!

changeContext_color: aChar

	color := aChar.!

changeContext_EM

	s ifFalse: [ em := em not ].!

changeContext_I

	i := true.!

changeContext_PL

	u := 0.
	s := false.
	em := false.
	i := false.
	b := false.
	tt := false.!

changeContext_S

	s := true.
	em := false.!

changeContext_size: anInteger

	size := anInteger.!

changeContext_TT

	tt := true.!

changeContext_U

	(u < 3) ifTrue: [ u := u + 1 ].!

changeContextForTag: aTag

	^(DirectedMessage
		receiver: self
		selector: aTag contextSelector
		arguments: aTag contextArgs) send!

color
	^color!

em
	^em!

hash

	"So we can compare for equality."

	| val |
	val := 0.

	b ifTrue: [ val := val + 163200 ]. "255*10*4*2*2*2*2"
	em ifTrue: [ val := val +81600 ]. "255*10*4*2*2*2"
	i ifTrue: [ val := val +40800 ]. "255*10*4*2*2"
	s ifTrue: [ val := val +20400 ]. "255*10*4*2"
	tt ifTrue: [ val := val +10200 ]. "255*10*4"

	val := val + (u * 2550). "255 * 10"
	val := val + (size * 255).
	val := val + color value.

	^val!

i
	^i!

initialize

	"This object gets shallow copied often, so it is important to keep its
	contents simple objects."

	b := false.
	em := false.
	i := false.
	s := false.
	tt := false.
	u := 0.
	"Keep size and color as nil -- we don't know them initially"!

makeSpaceContext

	s := false.
	em := false.
	i := false.
	b := false.

	(u == 0) ifTrue: [ color := $w ].!

noPlAttribsSet

	^(b | em | i | s | tt) not and: [ u == 0 ]!

printOn: aStream

	b ifTrue: [ aStream nextPutAll: 'b ' ].
	em ifTrue: [ aStream nextPutAll: 'em ' ].
	i ifTrue: [ aStream nextPutAll: 'i ' ].
	s ifTrue: [ aStream nextPutAll: 's ' ].
	tt ifTrue: [ aStream nextPutAll: 'tt ' ].
	(u > 0) ifTrue: [ aStream nextPutAll: ('(u = %1) ' bindWith: u printString) ].
	aStream nextPutAll: ('size = %1; color = %2' bindWith: size printString with: color printString).!

s
	^s!

size
	^size!

tt
	^tt!

u
	^u! !

!CwcIcfp2001 class publicMethods !

getInput

	| f |

	"stdin -> file descriptor number 0"
	"Works on UNIX only I think..."

	f := CfsFileStream on:
		((CfsFileDescriptor on: 0)
			oflag: ORDONLY;
			share: ODENYNONE;
			yourself).

	^f contents!

go

	| c toks opt timeLimit remainingTime firstWarning maxOutputTime emergencyWarning emergencyOutput numChars numToks clockStartTime timer previousSize firstPass |

	"APPLICATION ENTRY POINT"

	Process stackOverflowWarningSize:  131072.
	clockStartTime := Time millisecondClockValue.

	timeLimit := 'TLIMIT' abtScanEnv asNumber.
	"Uh oh, something went wrong.  Fall back to guaranteed min time of 180."
	(timeLimit == 0) ifTrue: [ timeLimit := 180 ].

	maxOutputTime := 100.
	firstWarning := maxOutputTime.
	emergencyWarning := 10.
	remainingTime := timeLimit.

	timer :=
		[ (Delay forSeconds: (timeLimit - maxOutputTime)) wait.
			[ true ] whileTrue:
				[ remainingTime := timeLimit - ((Time millisecondClockValue - clockStartTime) / 1000).
				(remainingTime < emergencyWarning) ifTrue: [ self outputAndQuit: emergencyOutput or: c.  self halt. ].
				(Delay forSeconds: 1) wait ] ] forkAt: Processor timingPriority.

	c := self getInput.
	emergencyOutput := c.
	"Update firstWarning and maxOutputTime now that we know the input size."
	"The following hardcoded numbers are arbitrary tweak factors."
	maxOutputTime := (1.34e-5 * c size) rounded + 5.
	firstWarning := maxOutputTime + (2.67e-5 * c size) rounded + 10.

	toks := CwcStringToTokensStreamConverter convertAllOfCollection: c.
	opt := CwcTokenCollectionOptimizer onCollection: toks.

	numChars := c size.
	numToks := toks size.

	CwcTokenCollectionOptimizer firstPassOperationSelectorsAndTimeBlocks do:
		[ :each | | operationTime |
		(DirectedMessage receiver: opt selector: (each at: 1) arguments: #()) send.
		(remainingTime < maxOutputTime) ifTrue:
			[ operationTime := (each at: 2) value: numChars value: numToks.
			(remainingTime < maxOutputTime) ifTrue: [ emergencyOutput := opt output ] ] ].

	"Ordinarliy I only use this one for rabbit hunting, but it should do the trick in this situation too"
	firstPass := true.
	[ firstPass
		ifTrue: [ firstPass := false.  true ]
		ifFalse:
			[ previousSize := emergencyOutput size.
			(emergencyOutput := opt output) size < previousSize ] ] whileTrue:

		"Let's try that again, huh?"
		[ CwcTokenCollectionOptimizer loopOperationSelectorsAndTimeBlocks do:
			[ :each | | operationTime |
			(remainingTime < firstWarning) ifTrue:
				[ operationTime := (each at: 2) value: numChars value: numToks.
				(remainingTime < (operationTime + maxOutputTime)) ifTrue: [ emergencyOutput := opt output ] ].
			(DirectedMessage receiver: opt selector: (each at: 1) arguments: #()) send. ] ].

	self outputAndQuit: opt output or: c.
	timer terminate.!

outputAndQuit: string1 or: string2

	Transcript nextPutAll: ((string1 size < string2 size) ifTrue: [ string1 ] ifFalse: [ string2 ]).

	System isRuntime
		ifTrue: [ System image exit ]
		ifFalse: [ | t | t :=  Time millisecondClockValue. Transcript cr; nextPutAll: 'Finish: ', t printString ]! !

!CwcNode class publicMethods !

new

	^super new initialize!

onToken: aToken fromNode: parentNode

	^self new
		token: aToken;
		parent: parentNode;
		yourself!

rootNode

	^CwcRootNode new! !

!CwcNode publicMethods !

computeContext

	| ctx |
	ctx := CwcDecorationContext new.

	self getParentTagCollection do:
		[ :each | ctx changeContextForTag: each ].

	^ctx!

initialize!

isRootNode
	^false!

isTextNode
	^false!

parent
	^parent!

parent: aNode
	parent := aNode!

token
	^token!

token: aToken
	token := aToken.!

walkTreeForBlock: aTwoArgBlock

	self walkTreeForBlock: aTwoArgBlock useClosingTags: false.!

walkTreeForBlockIncludingRoot: aBlock

	^self walkTreeForBlock: aBlock useClosingTags: false! !

!CwcRootNode publicMethods !

checkTree

	self walkTreeForBlock:
		[ :walkingToken :walkingNode |
		(walkingToken isTag and: [ walkingNode children isEmpty ]) ifTrue: [ self halt ] ]!

deleteAllChildrenConforming: aBlock

	"A block is a one-argument block"

	children copy do: [ :each | each deleteAllChildrenConforming: aBlock ].!

getParentTagCollection

	^OrderedCollection new!

isRootNode
	^true!

postWalkTreeForBlock: aTwoArgBlock

	children copy do: [ :each | each postWalkTreeForBlock: aTwoArgBlock ].!

walkTreeForBlock: aTwoArgBlock useClosingTags: aBoolean

	children copy do: [ :each | each walkTreeForBlock: aTwoArgBlock useClosingTags: aBoolean ].!

walkTreeForBlockIncludingRoot: aTwoArgBlock

	aTwoArgBlock value: token value: self.
	children do: [ :each | each walkTreeForBlock: aTwoArgBlock useClosingTags: false ].! !

!CwcStreamConverter class publicMethods !

convertAllOf: aStream

	| converterStream output |
	output := OrderedCollection new.
	converterStream := self on: aStream.

	[ converterStream atEnd ] whileFalse: [ output add: converterStream next ].

	^output!

convertAllOfCollection: aCollection

	| converterStream output |
	output := OrderedCollection new.
	converterStream := self on: (ReadStream on: aCollection).

	[ converterStream atEnd ] whileFalse: [ output add: converterStream next ].

	^output!

new

	^super new initialize!

on: aStream

	^self new
		inputStream: aStream;
		yourself! !

!CwcStreamConverter publicMethods !

addAllToBuffer: aCollection

	bufferedObjects addAll: aCollection!

addToBuffer: anObject

	bufferedObjects add: anObject.!

atEnd

	self ensureObjectsAreBuffered.
	^bufferedObjects isEmpty!

basicBufferMoreObjects

	"Must buffer at least one more object if more are available.
	If none are available, takes no action."

	^self subclassResponsibility!

bufferMoreObjects


	inputStream atEnd ifTrue: [ ^nil ].
	self basicBufferMoreObjects!

ensureObjectsAreBuffered

	bufferedObjects isEmpty ifTrue: [ self bufferMoreObjects ].!

initialize

	"Queue - add to end, take off beginning."
	bufferedObjects := OrderedCollection new.!

inputStream: aStream

	inputStream := aStream.!

next

	self ensureObjectsAreBuffered.
	^bufferedObjects isEmpty
		ifTrue: [ nil ]
		ifFalse: [ bufferedObjects removeFirst ]!

peek

	self ensureObjectsAreBuffered.
	^bufferedObjects isEmpty
		ifTrue: [ nil ]
		ifFalse: [ bufferedObjects first ]! !

!CwcStringToTokensStreamConverter publicMethods !

basicBufferMoreObjects

	self addToBuffer:
		((inputStream peek == $<)
			ifTrue: [ self getNextTag ]
			ifFalse: [ self getNextText ])!

getNextTag

	| tag |
	tag := WriteStream on: String  new.

	inputStream next. "Skip leading <"
	[ inputStream atEnd | (inputStream peek == $>) ] whileFalse: [ tag nextPut: inputStream next ].
	inputStream next. "Skip trailing >"

	^CwcTag on: tag contents!

getNextText

	| text |
	text := WriteStream on: String new.

	[ inputStream atEnd | (inputStream peek == $<) ] whileFalse: [ text nextPut: inputStream next ].
	^CwcText on: text contents! !

!CwcTag publicMethods !

asClosingTag

	^self class on: ('/', contents)!

contextArgs

	^contents first isDigit
		ifTrue: [ Array with: contents asNumber ]
		ifFalse: [
			contents first isLowercase
				ifTrue: [ Array with: contents first ]
				ifFalse: [ #() ] ]!

contextSelector

	"Aw man...One of them dang birds done crapped on my ma's carpet"

	^(contents first isDigit
		ifTrue: [ 'changeContext_size:' ]
		ifFalse:
			[ contents first isLowercase
				ifTrue: [ 'changeContext_color:' ]
				ifFalse: [ 'changeContext_', contents ] ]) asSymbol!

isClosingTag

	^contents first == $/!

isHiddenByPl

	^(self isOpeningColorTag or: [ self isOpeningSizeTag ]) not!

isOpeningColorTag

	^contents first isLowercase!

isOpeningSizeTag

	^contents first isDigit!

isOpeningTag

	^self isClosingTag not!

isRedundantEnclosedTag: aTag

	(self contents = 'B') ifTrue: [ ^aTag contents = 'B' ].
	(self contents = 'I') ifTrue: [ ^aTag contents = 'I' ].
	(self contents = 'S') ifTrue: [ ^(aTag contents = 'S') | (aTag contents = 'EM') ].
	(self contents = 'TT') ifTrue: [ ^aTag contents = 'TT' ].
	(self contents = 'PL') ifTrue: [ ^aTag contents = 'PL' ].

	self isOpeningColorTag ifTrue: [ ^aTag isOpeningColorTag ].
	self isOpeningSizeTag ifTrue: [ ^aTag isOpeningSizeTag ].

	(self contents = 'U') ifTrue: [ ^(aTag contents = 'U') and: [ aTag context u = 3 ] ].

	^false!

isTag
	^true!

printOn: aStream

	aStream
		nextPut: $<;
		nextPutAll: contents;
		nextPut: $>.! !

!CwcTagNode publicMethods !

addTokenToTree: aToken

	^aToken isTag
		ifTrue:
			[ aToken isClosingTag
				ifTrue: [ self parent ]
				ifFalse: [children add: (CwcTagNode onToken: aToken fromNode: self) ] ]
		ifFalse: [ children add: (CwcTextNode onToken: aToken fromNode: self).  self ]!

bringTagToTop: aTag

	| movingNode |

	movingNode := self findNodeForTag: aTag.

	(movingNode == self) ifFalse:
		[ movingNode deleteNode.

		 movingNode parent: self parent.

		movingNode children: (OrderedCollection with: self).
		self parent children at: (self parent children indexOf: self) put: movingNode.
		self parent: movingNode. ].

	^movingNode!

bringTagToTop: aTag nodeIndex: anInteger

	| movingNode |

	movingNode := self findNodeForTag: aTag.

	(movingNode == self) ifFalse:
		[ movingNode deleteNode.

		 movingNode parent: self parent.

		movingNode children: (OrderedCollection with: self).
		self parent children at: anInteger put: movingNode.
		self parent: movingNode. ].

	^LookupTable new
		at: #node put: movingNode;
		at: #index put: anInteger;
		yourself!

children

	^children!

children: anOrderedCollection

	children := anOrderedCollection.!

deleteAllChildrenConforming: aBlock

	"A block is a one-argument block"

	children copy do: [ :each | each deleteAllChildrenConforming: aBlock ].

	(aBlock value: self) ifTrue: [ self deleteNode ].!

deleteChild: aChild

	children remove: aChild ifAbsent: [ self error: 'Trying to delete a child that I do not have' ].!

deleteNode

	parent replaceChild: self withChildren: children.!

findNodeForTag: aTag

	"Assumes that each node encountered before tag is found
	has only one child."

	^(self token contents = aTag contents)
		ifTrue: [ self ]
		ifFalse: [ self children first findNodeForTag: aTag ]!

firstChildTagDepth: anInteger

	^(anInteger == 0)
		ifTrue: [ self ]
		ifFalse: [ self children first firstChildTagDepth: anInteger - 1 ]!

getParentTagCollection

	^parent getParentTagCollection add: self token; yourself!

initialize

	super initialize.
	children := OrderedCollection new.!

lastChildTagDepth: anInteger

	^(anInteger == 0)
		ifTrue: [ self ]
		ifFalse: [ self children last lastChildTagDepth: anInteger - 1 ]!

outputString

	| ws |

	ws := WriteStream on: String new.

	self walkTreeForBlock: [ :t :n | ws nextPutAll: t printString ] useClosingTags: true.

	^ws contents!

possibleTopTags

	"U's can't rise to the top unless the underline context is already 3"
	"PL's can't rise to the top."

	^((children size == 1) and:
			[ children first token isTag and:
			[ (children first token contents ~= 'PL') and:
			[ (children first token contents ~= 'U' or: [ token context u == 3 ]) ] ] ])

		ifTrue: [ children first possibleTopTags add: token; yourself ]
		ifFalse: [ OrderedCollection with: token ]!

postWalkTreeForBlock: aTwoArgBlock

	"Does not do closing tags."

	children copy do: [ :each | each postWalkTreeForBlock: aTwoArgBlock ].
	aTwoArgBlock value: token value: self.!

replaceChild: aChild withChildren: anOrderedCollection

	children
		addAll: anOrderedCollection before: aChild;
		remove: aChild.

	children do: [ :each | each parent: self ].!

walkTreeForBlock: aTwoArgBlock useClosingTags: aBoolean

	aTwoArgBlock value: token value: self.
	children copy do: [ :each | each walkTreeForBlock: aTwoArgBlock useClosingTags: aBoolean ].
	aBoolean ifTrue: [ aTwoArgBlock value: token asClosingTag value: self ].! !

!CwcText publicMethods !

reduceWhiteSpace

	context tt ifFalse: [ contents := contents cwcWithoutExtraneousWhiteSpace ].! !

!CwcTextNode publicMethods !

children
	^OrderedCollection new!

deleteAllChildrenConforming: aBlock

	(aBlock value: self) ifTrue: [ self deleteNode ].!

deleteNode

	parent deleteChild: self!

firstChildTagDepth: anInteger

	"In too deep...return nil"

	^nil!

getParentTagCollection

	^parent getParentTagCollection!

isTextNode
	^true!

lastChildTagDepth: anInteger

	"In too deep...return nil"

	^nil!

possibleTopTags

	^OrderedCollection new!

postWalkTreeForBlock: aTwoArgBlock

	aTwoArgBlock value: token value: self.!

walkTreeForBlock: aTwoArgBlock useClosingTags: aBoolean

	aTwoArgBlock value: token value: self.! !

!CwcToken class publicMethods !

on: aString

	^self new
		contents: aString;
		yourself! !

!CwcToken publicMethods !

contents
	^contents!

contents: aString
	contents := aString.!

context
	^context!

context: aContext
	context := aContext.!

isClosingTag
	^false!

isOpeningColorTag
	^false!

isOpeningSizeTag
	^false!

isOpeningTag
	^false!

isTag
	^false!

printOn: aStream

	aStream nextPutAll: contents.! !

!CwcTokenCollectionOptimizer class publicMethods !

firstPassOperationSelectorsAndTimeBlocks

	"Order is important."

	^OrderedCollection new
		add: (Array with: #eliminateTextlessTags with: [ :numChars :numToks | (numToks * 2.86e-5) rounded + 10 ]); "30 secs"
		add: (Array with: #removeWhiteSpaceFromTexts with: [ :numChars :numToks | (numChars > 1000000) ifTrue: [ 30 ] ifFalse: [ 15 ] ]);
		add: (Array with: #removeRedundantTagsCorrectContext with: [ :numChars :numToks | (numToks * 2.86e-5) rounded + 10 ]); "30 secs"
		yourself!

loopOperationSelectorsAndTimeBlocks

	"Order is important."

	^OrderedCollection new
		add: (Array with: #removeSubsumedTags with: [ :numChars :numToks | 5 ]);
		add: (Array with: #removeNestedColorAndSizeTags with: [ :numChars :numToks | 5 ]);
		add: (Array with: #removeRepeatedEMTags with: [ :numChars :numToks | 5 ]);
		add: (Array with: #shuffleTagHierarchyDepth0 with: [ :numChars :numToks | (numToks * 5.72e-5) rounded + 10 ]); "60 secs"
		add: (Array with: #shuffleTagHierarchyDepth1 with: [ :numChars :numToks | 5 ]);
		add: (Array with: #shuffleTagHierarchyDepth2 with: [ :numChars :numToks | 5 ]);
		add: (Array with: #shuffleTagHierarchyDepth3 with: [ :numChars :numToks | 5 ]);
		add: (Array with: #applyPlShortcut with: [ :numChars :numToks | (numToks * 5.72e-5) rounded + 10 ]); "60 secs"
		yourself!

new

	^super new initialize!

onCollection: aCollection

	^self new
		tokenCollection: aCollection;
		yourself! !

!CwcTokenCollectionOptimizer publicMethods !

applyPlShortcut

	rootNode walkTreeForBlockIncludingRoot:
		[ :token :node |
		((node isRootNode or: [ node token context noPlAttribsSet ]) and: [ node children size >= 3 ]) ifTrue:
			[ | workingIndex |
			workingIndex := 2.
			[ workingIndex < node children size ] whileTrue:
				[ | prevChild eachChild nextChild topTagIntersection insertionPoint insertedDataPoint newPlNode madeAdjustment |
				madeAdjustment := false.
				eachChild := node children at: workingIndex.
				eachChild isTextNode ifTrue:
					[ "Optimization -- remember the index to avoid having to search long lists of children."
					prevChild := Dictionary new
						at: #node put: (node children at: (workingIndex - 1));
						at: #index put: (workingIndex - 1);
						yourself.
					nextChild := Dictionary new
						at: #node put: (node children at: (workingIndex + 1));
						at: #index put: (workingIndex + 1);
						yourself.

					topTagIntersection := (self findPossibleTopTagIntersectionFor: (prevChild at: #node) and: (nextChild at: #node))
						select: [ :eachTag | eachTag isHiddenByPl ].

					(topTagIntersection size >= 2) ifTrue:
						[ topTagIntersection do:
							[ :eachTopTag |
							prevChild := (prevChild at: #node) bringTagToTop: eachTopTag nodeIndex: (prevChild at: #index).
							nextChild := (nextChild at: #node) bringTagToTop: eachTopTag nodeIndex: (nextChild at: #index). ].

						insertionPoint := (prevChild at: #node).
						insertedDataPoint := (nextChild at: #node).
						(topTagIntersection size - 1) timesRepeat:
							[ insertionPoint := insertionPoint children first.
							insertedDataPoint := insertedDataPoint children first. ].

						newPlNode := CwcTagNode onToken: (CwcTag on: 'PL') fromNode: insertionPoint.
						newPlNode token context: insertionPoint children first token context.
						insertionPoint children add: newPlNode.

						newPlNode children add: eachChild.
						eachChild parent: newPlNode.
						node children remove: eachChild.

						insertedDataPoint children do:
							[ :eachInsertedChild |
							insertionPoint children add: eachInsertedChild.
							eachInsertedChild parent: insertionPoint ].
						node children remove: (nextChild at: #node).
						madeAdjustment := true ] ].
				madeAdjustment ifFalse: [ workingIndex := workingIndex + 1 ] ] ] ]!

buildCopyTreeFrom: sourceChild depth: anInteger useFirsts: aBoolean

	^(anInteger > 0)
			ifTrue:
				[ | copyTree place |
				copyTree := sourceChild copy.
				place := copyTree.
				(anInteger - 1) timesRepeat:
					[ | nextStep |
					nextStep := aBoolean
						ifTrue: [ place children first ]
						ifFalse: [ place children last ].
					place children: (OrderedCollection with: nextStep copy).
					place := place children first ].
				place children: OrderedCollection new.
				copyTree ]
		ifFalse: [ nil ]!

buildTree: aCollection

	| workingNode |

	rootNode := CwcNode rootNode.
	workingNode := rootNode.

	aCollection do:
		[ :each |
		each context: self currentContext copy.
		each isTag ifTrue: [ self changeContextForTag: each ].
		workingNode := workingNode addTokenToTree: each ]!

chagneContextForOpeningTag: aTag

	self saveCurrentContext.

	self currentContext changeContextForTag: aTag.!

changeContextForClosingTag: aTag

	self restorePreviousContext.!

changeContextForTag: aTag

	aTag isClosingTag
		ifTrue: [ self changeContextForClosingTag: aTag ]
		ifFalse: [ self chagneContextForOpeningTag: aTag ]!

checkTree

	rootNode checkTree.!

currentContext

	^contexts last!

doNestedColorAndSizeCheckForChildIndex: anInteger ofNode: aNode

	"We're checking to see if:
		1. the current, previous, and next children are color or size tags
		2. the previous and next color or size tags are the same.
	If the check is true, we re-arrange the tree.
	The method returns boolean - true if the current child checks out."

	| currentChild previousChild nextChild |

	currentChild := aNode children at: anInteger.
	previousChild := aNode children at: (anInteger - 1).
	nextChild := aNode children at: (anInteger + 1).

	^(((currentChild token isOpeningColorTag & previousChild token isOpeningColorTag & nextChild token isOpeningColorTag) |
			(currentChild token isOpeningSizeTag & previousChild token isOpeningSizeTag & nextChild token isOpeningSizeTag)) &
			(previousChild token contents = nextChild token contents))
		ifTrue:
			[ previousChild children add: currentChild.
			aNode children remove: currentChild.
			currentChild parent: previousChild.

			nextChild children do:
				[ :eachChild |
				previousChild children add: eachChild.
				eachChild parent: previousChild. ].
			aNode children remove: nextChild.
			true ]
		ifFalse: [ false ]!

eliminateTextlessTags

	rootNode postWalkTreeForBlock:
		[ :token :node |
		(token isOpeningTag and: [ node children isEmpty ])
			ifTrue: [ node deleteNode ] ].!

findPossibleTopTagIntersectionFor: childOne and: childTwo

	| onePossibleTops |

	onePossibleTops := childOne possibleTopTags.
	^childTwo possibleTopTags select:
		[ :eachTag | (onePossibleTops findFirst: [ :innerEachTag | innerEachTag contents = eachTag contents]) > 0 ].
!

initialize

	"Stack - top is at end."
	contexts := OrderedCollection with: CwcDecorationContext new.!

output

	| ws |

	ws := WriteStream on: String new.

	rootNode walkTreeForBlock: [ :token :node | token printOn: ws ] useClosingTags: true.

	^ws contents!

removeNestedColorAndSizeTags

	rootNode walkTreeForBlockIncludingRoot:
		[ :token :node | | workingIndex |
		workingIndex := 2.
		[ workingIndex < node children size ] whileTrue:
			[ (self doNestedColorAndSizeCheckForChildIndex: workingIndex ofNode: node)
				ifTrue: [ workingIndex := (workingIndex - 1) max: 2 ]
				ifFalse: [ workingIndex := workingIndex + 1 ] ] ].!

removeRedundantTags

	"Removes EM tags that are subsumed by S tags.
	e.g. <S><EM> hi </EM></S> ==> <S> hi </S>"

	rootNode deleteAllChildrenConforming:
		[ :child | | childContext |
		child token isTag
			ifTrue:
				[ childContext := child computeContext.
				(child token isTag & (child token contents = 'EM') & childContext s) or: [
				(child token isTag & (child token contents = 'B') & childContext b) or: [
				(child token isTag & (child token contents = 'I') & childContext i) or: [
				(child token isTag & (child token contents = 'S') & childContext s) or: [
				(child token isTag & (child token contents = 'TT') & childContext tt) or: [
				(child token isTag & (child token contents = 'PL') & childContext noPlAttribsSet) or: [
				(child token isTag & (child token contents = 'U') & (childContext u = 3)) or: [
				(child token isTag & (child token contents first isDigit) & (childContext size = child token contents asNumber)) or: [
				(child token isTag & (child token contents first isLowercase) & (childContext color = child token contents first)) ] ] ] ] ] ] ] ] ]
			ifFalse: [ false ] ].!

removeRedundantTagsCorrectContext

	"Removes EM tags that are subsumed by S tags.
	e.g. <S><EM> hi </EM></S> ==> <S> hi </S>"

	"Assume contexts are correct.  This is only true at the beginning b/c keeping the contexts
	correct is expensive."

	rootNode deleteAllChildrenConforming:
		[ :child |
			(child token isTag & (child token contents = 'EM') & child token context s) or: [
			(child token isTag & (child token contents = 'B') & child token context b) or: [
			(child token isTag & (child token contents = 'I') & child token context i) or: [
			(child token isTag & (child token contents = 'S') & child token context s) or: [
			(child token isTag & (child token contents = 'TT') & child token context tt) or: [
			(child token isTag & (child token contents = 'PL') & child token context noPlAttribsSet) or: [
			(child token isTag & (child token contents = 'U') & (child token context u = 3)) or: [
			(child token isTag & (child token contents first isDigit) & (child token context size = child token contents asNumber)) or: [
			(child token isTag & (child token contents first isLowercase) & (child token context color = child token contents first)) ] ] ] ] ] ] ] ] ].
!

removeRepeatedEMTags

	"Removes EM tags that are repeated.
	e.g. <EM><EM> hi </EM></EM> ==>  hi "

	rootNode walkTreeForBlock:
		[ :token :node |
		(((node children size == 1) & (token contents = 'EM')) and: [ node children first token isTag & (node children first token contents = 'EM') ])
			ifTrue:
				[ node children first deleteNode.
				node deleteNode ] ].!

removeSubsumedTags

	"Removes EM tags that are subsumed by S tags.
	e.g. <S><EM> hi </EM><S> ==> <S> hi </S>

	Also look at color & size tags"

	| redundantTag |

	rootNode walkTreeForBlock:
		[ :token :node |
		((node children size == 1) and:
				[ | possibleTops index |
				possibleTops := node children first possibleTopTags.
				index := possibleTops findFirst: [ :eachTag | token isRedundantEnclosedTag: eachTag ].
				(index > 0)
					ifTrue: [ redundantTag := possibleTops at: index.  true ]
					ifFalse: [ false ] ])

			ifTrue:
				"For S tags, we have to eliminate the inner tag cuz it might be EM"
				[ (token contents = 'S')
					ifTrue: [ (node findNodeForTag: redundantTag) deleteNode ]
					ifFalse: [ node deleteNode ] ] ].!

removeWhiteSpaceFromTexts

	| previousContext |

	rootNode walkTreeForBlock:
		[ :eachToken :node |
		eachToken isTag ifFalse:
			[ eachToken reduceWhiteSpace.

			"If the last space of the previous text has the same space context as the first space in the current text,
			we can remove the first space in the current text."
			(eachToken contents isEmpty not and:
					[ eachToken context tt not and:
					[ (eachToken contents first == CldtConstants::Space) and:
					[ previousContext notNil and:
					[ previousContext makeSpaceContext = eachToken context makeSpaceContext ] ] ] ])
				ifTrue: [ eachToken contents: (eachToken contents copyFrom: 2 to: eachToken contents size) ].

			"Remember the last space in the current text for next time."
			"If the token was emptied, do nothing -- previousContext is still vaid."
			eachToken contents isEmpty ifFalse:
				[ (eachToken contents last == CldtConstants::Space)
				ifTrue: [ previousContext := eachToken context ]
				ifFalse: [ previousContext := nil ] ].

			"We might have an empty string on our hands."
			eachToken contents isEmpty ifTrue:
				[ | workingNode |
				workingNode := node parent.
				node deleteNode.
				[ workingNode children isEmpty ] whileTrue:
					[ workingNode deleteNode.
					workingNode := workingNode parent ] ] ] ].!

restorePreviousContext

	contexts removeLast.!

saveCurrentContext

	contexts add: contexts last copy.!

shuffleTagHierarchyDepth: anInteger

	| workingIndex targetChild sourceChild copyTree sourcePlace |

	rootNode walkTreeForBlockIncludingRoot:
		[ :token :node | 
		workingIndex := 1.
		[ workingIndex < node children size ] whileTrue:
			[ "Do all forward shuffles at this location"
			[ (workingIndex < node children size)
				ifTrue: [
					targetChild := node children at: workingIndex.
					sourcePlace := node children at: workingIndex + 1.
					sourceChild := sourcePlace firstChildTagDepth: anInteger ]
				ifFalse: [ sourceChild := nil ].

			sourceChild isNil
				ifTrue: [ false ]
				ifFalse:
					[ copyTree := self buildCopyTreeFrom: sourcePlace depth: anInteger useFirsts: true.
					self shuffleTreeTo: targetChild from: sourceChild copyTree: copyTree depth: anInteger forward: true ] ] whileTrue: [ ].

			"Do all backwards shuffles at this location."
			"Don't need to backwards shuffle if depth = 0 cuz its symmetrical"
			(anInteger > 0) ifTrue:
				[ [ (workingIndex < node children size)
					ifTrue:
						[ targetChild := node children at: workingIndex + 1.
						sourcePlace := node children at: workingIndex.
						sourceChild := sourcePlace lastChildTagDepth: anInteger ]
					ifFalse: [ sourceChild := nil ].

				sourceChild isNil
					ifTrue: [ false ]
					ifFalse:
						[ copyTree := self buildCopyTreeFrom: sourcePlace depth: anInteger useFirsts: false.
						self shuffleTreeTo: targetChild from: sourceChild copyTree: copyTree depth: anInteger forward: false ] ] whileTrue: [ ] ].
			workingIndex := workingIndex + 1. ] ].!

shuffleTagHierarchyDepth0

	self shuffleTagHierarchyDepth: 0.!

shuffleTagHierarchyDepth1

	self shuffleTagHierarchyDepth: 1.!

shuffleTagHierarchyDepth2

	self shuffleTagHierarchyDepth: 2.!

shuffleTagHierarchyDepth3

	self shuffleTagHierarchyDepth: 3.!

shuffleTreeTo: targetChild from: sourceChild copyTree: copyTree depth: anInteger forward: aBoolean

	| topTagIntersection |

	topTagIntersection := self findPossibleTopTagIntersectionFor: targetChild and: sourceChild.

	^(topTagIntersection size <= anInteger)
		ifTrue: [ false ]
		ifFalse:
			[ | targetChildPlace sourceChildPlace insertionPoint insertedDataPoint |
			targetChildPlace := targetChild.
			sourceChildPlace := sourceChild.
			topTagIntersection do:
				[ :eachTopTag |
				targetChildPlace := targetChildPlace bringTagToTop: eachTopTag.
				sourceChildPlace := sourceChildPlace bringTagToTop: eachTopTag. ].

			insertionPoint := targetChildPlace.
			insertedDataPoint := sourceChildPlace.
			"The following is okay b/c these nodes are guaranteed to have only one child each."
			(topTagIntersection size  - 1) timesRepeat:
				[ insertionPoint := insertionPoint children first.
				insertedDataPoint := insertedDataPoint children first. ].

			copyTree notNil ifTrue:
				[ aBoolean
					ifTrue: [ insertionPoint children add: copyTree ]
					ifFalse: [ insertionPoint children addFirst: copyTree ].
				copyTree parent: insertionPoint.
				anInteger timesRepeat:
					[ insertionPoint := aBoolean
						ifTrue: [ insertionPoint children last ]
						ifFalse: [ insertionPoint children first ] ] ].

			insertedDataPoint children do:
				[ :eachInsertedChild |
				insertionPoint children add: eachInsertedChild.
				eachInsertedChild parent: insertionPoint ].

			sourceChildPlace parent children remove: sourceChildPlace.
			true ]!

tokenCollection: aCollection

	self buildTree: aCollection.! !

!Object class publicMethods !

cwcNotDone! !

!Object publicMethods !

cwcNotDone! !

!String publicMethods !

cwcWithoutExtraneousWhiteSpace

	| reducedStream inWhitespace |

	inWhitespace := false.
	reducedStream := WriteStream on: String new.

	self do:
		[ :each |
		each cwcIsWhitespace
			ifTrue: [ inWhitespace ifFalse: [ inWhitespace := true.  reducedStream nextPut: Space ] ]
			ifFalse: [ inWhitespace := false. reducedStream nextPut: each ] ].

	^reducedStream contents! !

CwcDecorationContext initializeAfterLoad!
CwcNode initializeAfterLoad!
CwcTagNode initializeAfterLoad!
CwcRootNode initializeAfterLoad!
CwcTextNode initializeAfterLoad!
CwcStreamConverter initializeAfterLoad!
CwcStringToTokensStreamConverter initializeAfterLoad!
CwcToken initializeAfterLoad!
CwcTag initializeAfterLoad!
CwcText initializeAfterLoad!
CwcTokenCollectionOptimizer initializeAfterLoad!
CwcIcfp2001 initializeAfterLoad!

CwcIcfp2001 loaded!